#include "arm9.h"

#ifdef PROTECTED_ENABLED

typedef struct {
	u16 part3src;
	u16 part4src;
	u16 part34crc;
	u16 part12crc;
	char fwcode[4];
	u16 part1src;
	u16 part1dst;
	u16 part2src;
	u16 part2dst;
	u16 part12shift;
	u16 part5src;
	u32 enPngOff[2];
	u16 usersettings;
	u16 _22[2];
	u16 part5crc;
	u16 _28;
	u16 headercrc;
	u16 headersize;
	u16 _2E;
	u8  _30[6];
	u8  MAC_addr[6];
	u32 EnabledChannels;
	u8  RFInitFlag;
	u8  BitsperRFInitTransfer;
	u8  NumRFInitEntries;
	u8  _43;
	u16 WifiInit[16];
	u8  BasebandInit[105];
	u8  RFInitData[36];
	u8  ChannelRFdata[6][14];
	u8  ChannelBBdata[14];
	u8  _154[14];
	u8  _162;
} PACKED PROTECTEDDATA;

static PROTECTEDDATA *protectedData=(PROTECTEDDATA*)0x2700000;

#define PART1SRC protectedData->part1src * (4 << ((protectedData->part12shift>>0) & 7))
#define PART1DST 0x2800000 - (protectedData->part1dst * (4 << ((protectedData->part12shift>>3) & 7)))
#define PART2SRC protectedData->part2src * (4 << ((protectedData->part12shift>>6) & 7))
#define PART2DST (protectedData->part12shift & 0x1000 ? 0x02800000 : 0x03810000) - \
									(protectedData->part2dst * (4 << ((protectedData->part12shift>>9) & 7)))
#define PART3SRC protectedData->part3src * 8
#define PART4SRC protectedData->part4src * 8
#define PART5SRC protectedData->part5src * 8
#define USERSETTINGS protectedData->usersettings * 8

	
	
enum {
	PROTECTED_0,
	PROTECTED_FWCODE,
	PROTECTED_P1SRC,
	PROTECTED_P1DST,
	PROTECTED_P2SRC,
	PROTECTED_P2DST,
	PROTECTED_P3SRC,
	PROTECTED_P4SRC,
	PROTECTED_P5SRC,
	PROTECTED_P12CRC,
	PROTECTED_P34CRC,
	PROTECTED_P5CRC,
	PROTECTED_MACADDR,
	PROTECTED_USERSETTING,
	
#ifdef PROTECTED_WRITE
	PROTECTED_SAVE,
#endif
	PROTECTED_RETURN,
} PROTECTED_SELECTED;

char *text_protected[] = {
	"== PROTECTED SETTINGS ==",
	"FIRMWARE CODE: ---- ",
	"PART 1 SRC: ----- ",
	"PART 1 DST: ------- ",
	"PART 2 SRC: ----- ",
	"PART 2 DST: ------- ",
	"PART 3 SRC: ----- ",
	"PART 4 SRC: ----- ",
	"PART 5 SRC: ----- ",
	"PART 1+2 CRC: ---- ",
	"PART 3+4 CRC: ---- ",
	"PART 5 CRC: ---- ",
	"MAC ADDRESS: --:--:--:--:--:-- ",
	"USER SETTINGS: ----- ",
	
#ifdef PROTECTED_WRITE //Writing any Protected Settings to the DS is extremely risky.
	"RETURN AND SAVE",
	"RETURN WITHOUT SAVING",
#else
	"RETURN",
#endif
};
#define OPTS_protected (sizeof(text_protected)/sizeof(char*))


#endif //PROTECTED_ENABLED

