#include "arm9.h"

enum {
	MENURTCSETTING_0,
	MENURTCSETTING_MONTH,
	MENURTCSETTING_DAY,
	MENURTCSETTING_YEAR,
	MENURTCSETTING_HOUR,
	MENURTCSETTING_MINUTE,
	MENURTCSETTING_SAVE,
	MENURTCSETTING_RETURN,
} MENURTCSETTING_SELECTED;

char *text_rtcsetting[]={
//                                "
 "== RTC SETTINGS ==",
 "MONTH: -- ",
 "DAY: -- ",
 "YEAR: 20-- ",
 "HOUR: --/-- -- ",
 "MINUTE: -- ",
 "RETURN AND SAVE",
 "RETURN WITHOUT SAVING"};
#define OPTS_rtcsetting (sizeof(text_rtcsetting)/sizeof(char*))


extern char *text_userpref_month[];

int days_in_month(int month, int year)
{
	switch(month)
	{
	case 4:
	case 6:
	case 9:
	case 11:
		return 30;
	case 2:
		return ((year % 4) == 0) ? 29 : 28;
	default:
		return 31;
	}
}

int dayofweek(int days, int month, int year)
{
	int i;
	int total=5;

	for(i=0;i<year;i++)
		total += ((i % 4) == 0) ? 366 : 365;

	for(i=1;i<month;i++)
		total += days_in_month(i,year);
	total+=days;

	return total % 7;

}

void menu_rtcsetting() {
	u32 i,selected;
	u32 k;
	u8 month,day,year,hour,minute,weekday;

	month=IPC->curtime[2];
	day=IPC->curtime[3];
	year=IPC->curtime[1];
	hour=IPC->curtime[5];
	minute=IPC->curtime[6];
	
	sprintf(text_rtcsetting[MENURTCSETTING_MONTH],"MONTH: %.2d",month);
	sprintf(text_rtcsetting[MENURTCSETTING_DAY],"DAY: %.2d",day);
	sprintf(text_rtcsetting[MENURTCSETTING_YEAR],"YEAR: %.2d",year);
	sprintf(text_rtcsetting[MENURTCSETTING_HOUR],"HOUR: %.2d/%.2d %c%c",hour, 
					(hour > 11) ? hour - 12 : ((hour == 0) ? 12 : hour), (hour > 11) ? 'P' : 'A', 'M');
	sprintf(text_rtcsetting[MENURTCSETTING_MINUTE],"MINUTE: %.2d",minute);
	

	selected=0;
	while(1) {
		swiWaitForVBlank();
		
		for(i=0;i<OPTS_rtcsetting;i++)
			option3(text_rtcsetting,i,i==selected);

		k=keysDown();
		if(IPC_XKEYS & 0x80)	//lid closed
			arm9sleep();
		if(k&KEY_UP)
			selected--;
		if(k&KEY_DOWN)
			selected++;
		if(k&KEY_START)
			return;
		selected%=OPTS_rtcsetting;
		if(selected==0 && (k&KEY_UP)) selected=OPTS_rtcsetting-1;
		if(selected==0 && !(k&KEY_UP)) selected=1;
		if((k&KEY_LEFT) || (k&KEY_RIGHT) || (k&KEY_A) || (k&KEY_B)) {
			switch(selected) {
				
				case MENURTCSETTING_MONTH:
					if(k&KEY_LEFT) month=(month+12)%13;
					if(k&KEY_RIGHT) month=(month+1)%13;
					if((month==0)&&(k&KEY_LEFT)) month=12;
					if((month==0)&&(k&KEY_RIGHT)) month++;
					sprintf(text_rtcsetting[MENURTCSETTING_MONTH],"MONTH: %.2d",month);
					if(day > days_in_month(month,year))
					{
						day = days_in_month(month,year);
						sprintf(text_rtcsetting[MENURTCSETTING_DAY],"DAY: %.2d",day);
					}
					break;
					
				case MENURTCSETTING_DAY:
					if(k&KEY_LEFT) day=(day+days_in_month(month,year))%(days_in_month(month,year)+1);
					if(k&KEY_RIGHT) day=(day+1)%(days_in_month(month,year)+1);
					if((day==0)&&(k&KEY_LEFT)) day=days_in_month(month,year);
					if((day==0)&&(k&KEY_RIGHT)) day++;
					sprintf(text_rtcsetting[MENURTCSETTING_DAY],"DAY: %.2d",day);
					break;
					
				case MENURTCSETTING_YEAR:
					if(k&KEY_LEFT) year=(year+99)%100;
					if(k&KEY_RIGHT) year=(year+1)%100;
					if(k&KEY_A) year=(year+16)%100;
					if(k&KEY_B) year=(year+100-16)%100;
					sprintf(text_rtcsetting[MENURTCSETTING_YEAR],"YEAR: %.2d",year);
					if(day > days_in_month(month,year))
					{
						day = days_in_month(month,year);
						sprintf(text_rtcsetting[MENURTCSETTING_DAY],"DAY: %.2d",day);
					}
					break;
				
				case MENURTCSETTING_HOUR:
					if(k&KEY_LEFT) hour=(hour+23)%24;
					if(k&KEY_RIGHT) hour=(hour+1)%24;
					if((k&KEY_A) && hour>=12) hour-=12;
					if((k&KEY_B) && hour<12) hour+=12;
					sprintf(text_rtcsetting[MENURTCSETTING_HOUR],"HOUR: %.2d/%.2d %c%c",hour, 
					(hour > 11) ? hour - 12 : ((hour == 0) ? 12 : hour), (hour > 11) ? 'P' : 'A', 'M');
					break;
					
				case MENURTCSETTING_MINUTE:
					if(k&KEY_LEFT) minute=(minute+59)%60;
					if(k&KEY_RIGHT) minute=(minute+1)%60;
					if(k&KEY_A) minute=(minute+10)%60;
					if(k&KEY_B) minute=(minute+50)%60;
					sprintf(text_rtcsetting[MENURTCSETTING_MINUTE],"MINUTE: %.2d",minute);
					break;
					
			}
		}
		if(k&KEY_SELECT) {
			if(selected==MENURTCSETTING_SAVE)
			{
				weekday=dayofweek(day,month,year);
				IPC_RTC_0=0x64;
				IPC_RTC_1=year;
				IPC_RTC_2=month;
				IPC_RTC_3=day;
				IPC_RTC_4=weekday;
				IPC_RTC_5=hour;
				IPC_RTC_6=minute;
				IPC_RTC_7=0;
				IPC_ARM9 = IPC_WRITE_RTC;
				break;
			}
			if(selected==MENURTCSETTING_RETURN)
				break;
		}
	}
}

